/**
 * 
 */
package org.gcube.portlets.user.td.gwtservice.client.rpc;

import java.util.ArrayList;

import org.gcube.portlets.user.td.gwtservice.shared.codelisthelper.CodelistMappingSession;
import org.gcube.portlets.user.td.gwtservice.shared.csv.AvailableCharsetList;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVExportSession;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVImportSession;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CheckCSVSession;
import org.gcube.portlets.user.td.gwtservice.shared.extract.ExtractCodelistSession;
import org.gcube.portlets.user.td.gwtservice.shared.file.FileUploadMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.file.HeaderPresence;
import org.gcube.portlets.user.td.gwtservice.shared.history.OpHistory;
import org.gcube.portlets.user.td.gwtservice.shared.history.RollBackSession;
import org.gcube.portlets.user.td.gwtservice.shared.monitor.OperationMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.monitor.OperationMonitorSession;
import org.gcube.portlets.user.td.gwtservice.shared.sdmx.SDMXExportSession;
import org.gcube.portlets.user.td.gwtservice.shared.sdmx.SDMXImportSession;
import org.gcube.portlets.user.td.gwtservice.shared.share.ShareInfo;
import org.gcube.portlets.user.td.gwtservice.shared.source.SDMXRegistrySource;
import org.gcube.portlets.user.td.gwtservice.shared.task.TaskResubmitSession;
import org.gcube.portlets.user.td.gwtservice.shared.task.TaskResumeSession;
import org.gcube.portlets.user.td.gwtservice.shared.task.ValidationsTasksMetadata;
import org.gcube.portlets.user.td.gwtservice.shared.template.TemplateApplySession;
import org.gcube.portlets.user.td.gwtservice.shared.template.TemplateData;
import org.gcube.portlets.user.td.gwtservice.shared.template.TemplateDeleteSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.ColumnData;
import org.gcube.portlets.user.td.gwtservice.shared.tr.RefColumn;
import org.gcube.portlets.user.td.gwtservice.shared.tr.TabResource;
import org.gcube.portlets.user.td.gwtservice.shared.tr.TableData;
import org.gcube.portlets.user.td.gwtservice.shared.tr.batch.Occurrences;
import org.gcube.portlets.user.td.gwtservice.shared.tr.batch.OccurrencesForReplaceBatchColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.batch.ReplaceBatchColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.clone.CloneTabularResourceSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.AddColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.DeleteColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.LabelColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.ReplaceColumnSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.column.type.ChangeColumnTypeSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.metadata.TRMetadata;
import org.gcube.portlets.user.td.gwtservice.shared.tr.normalization.DenormalizationSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.normalization.NormalizationSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.open.TDOpenSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.paging.CodelistPagingLoadConfig;
import org.gcube.portlets.user.td.gwtservice.shared.tr.paging.CodelistPagingLoadResult;
import org.gcube.portlets.user.td.gwtservice.shared.tr.rows.DeleteRowsSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.rows.DuplicatesSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.rows.EditRowSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.table.ChangeTableTypeSession;
import org.gcube.portlets.user.td.gwtservice.shared.tr.table.metadata.TabMetadata;
import org.gcube.portlets.user.td.gwtservice.shared.tr.table.metadata.TabValidationsMetadata;
import org.gcube.portlets.user.td.gwtservice.shared.tr.type.Agencies;
import org.gcube.portlets.user.td.gwtservice.shared.tr.type.Codelist;
import org.gcube.portlets.user.td.gwtservice.shared.tr.type.Dataset;
import org.gcube.portlets.user.td.gwtservice.shared.tr.union.UnionSession;
import org.gcube.portlets.user.td.widgetcommonevent.shared.TRId;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * 
 * @author "Giancarlo Panichi" <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 * 
 */

public interface TDGWTServiceAsync {

	public static TDGWTServiceAsync INSTANCE = (TDGWTServiceAsync) GWT
			.create(TDGWTService.class);

	void hello(AsyncCallback<String> callback);	
	
	//TabularResource
	void getCurrentTRId(AsyncCallback<TRId> callback);
	void createTabularResource(TabResource tabResource,AsyncCallback<TabResource> callback);
	void removeTabularResource(TRId trId, AsyncCallback<Void> callback);   
	void isTabularResourceValid(TRId trId,AsyncCallback<Boolean> callback);
	void getTabResourceInformation(AsyncCallback<TabResource> callback);
	void getTabResourceInformation(TRId trId,AsyncCallback<TabResource> callback);	
	void setTabResourceInformation(TabResource tabResource, AsyncCallback<Void> callback);
	void getTRCreationDate(TRId trId,AsyncCallback<String> callback);
    void setTabResource(TabResource tabResource, AsyncCallback<Void> callback);
    void getTabularResources(AsyncCallback<ArrayList<TabResource>> callback);
    void getTabularResourcesAndLastTables(AsyncCallback<ArrayList<TabResource>> callback);
    void getLastTable(TRId trId, AsyncCallback<TableData> callback);
    void getTable(TRId trId, AsyncCallback<TableData> callback);
    void getTableMetadata(TRId trId, AsyncCallback<ArrayList<TabMetadata>> callback);
    void getTRMetadata(TRId trId, AsyncCallback<ArrayList<TRMetadata>> callback);
    void getColumns(AsyncCallback<ArrayList<ColumnData>> callback);
    void getColumns(TRId trId, AsyncCallback<ArrayList<ColumnData>> callback);
    void getColumnsForDimension(TRId trId, AsyncCallback<ArrayList<ColumnData>> callback);
    void getColumn(TRId trId, String columnName, AsyncCallback<ColumnData> callback);
    void getColumn(String columnLocalId,TRId trId, AsyncCallback<ColumnData> callback);
    void getConnection(RefColumn refColumn, AsyncCallback<ColumnData> callback);
    
    //Task
    void startTaskResubmit(TaskResubmitSession taskResubmitSession,AsyncCallback<String> callback);	
	void startTaskResume(TaskResumeSession taskResumeSession,AsyncCallback<String> callback);	
	

    //Validations
    void getValidationsTasksMetadata(TRId trId,AsyncCallback<ValidationsTasksMetadata> callback);
    void getTableValidationsMetadata(TRId trId,AsyncCallback<TabValidationsMetadata> callback);
    void getValidationColumns(TRId trId, String columnName, AsyncCallback<ArrayList<ColumnData>> callback);
    
    
    //RollBack
    void startRollBack(RollBackSession rollBackSession,AsyncCallback<String> callback);
    void startDiscard(TRId trId,AsyncCallback<String> callback);
    
    //Share
    void getShareInfo(TRId trId, AsyncCallback<ShareInfo> callback);
    
    void setShare(ShareInfo shareInfo, AsyncCallback<Void> callback);
    
    //CodelistPagingLoaded
	void setCodelistsPagingLoader(AsyncCallback<Void> callback);

	void getCodelistsPagingLoader(
			CodelistPagingLoadConfig codelistPagingLoadConfig,
			AsyncCallback<CodelistPagingLoadResult> callback);

    //Open
    void tdOpen(TDOpenSession tdOpenSession, AsyncCallback<Void> callback);
	
    //Clone
	String startCloneTabularResource(CloneTabularResourceSession cloneTabularResourceSession, AsyncCallback<String> callback);
	
    
    //SDMX
    void getCodelists(AsyncCallback<ArrayList<Codelist>> callback);

	void getDatasets(AsyncCallback<ArrayList<Dataset>> callback);
	
	void getAgencies(AsyncCallback<ArrayList<Agencies>> callback);
	
	void setSDMXRegistrySource(SDMXRegistrySource sdmxRegistrySource, AsyncCallback<Void> callback);
	
	//Import SDMX 
	void startSDMXImport(SDMXImportSession sdmxImportSession,AsyncCallback<String> callback);
    
	
	//Import CSV
	
	void setCSVSession(CSVImportSession csvImportSession, AsyncCallback<Void> callback);

	void getFileFromWorkspace(CSVImportSession csvImportSession, AsyncCallback<Void> callback);

	void getAvailableCharset(AsyncCallback<AvailableCharsetList> callback);
	
	void configureCSVParser(String encoding, HeaderPresence headerPresence, char delimiter, char comment, AsyncCallback<ArrayList<String>> callback);
	
	void checkCSV(long errorsLimit, AsyncCallback<CheckCSVSession> callback);
	
	void startCSVImport(CSVImportSession csvImportSession, AsyncCallback<String> callback);
	
	//Export CSV
	void startCSVExport(CSVExportSession csvExportSession, AsyncCallback<String> callback);
	
	//Export SDMX
	void startSDMXExport(SDMXExportSession exportSession, AsyncCallback<String> callback);
	
	
	//Table Operation
	void startChangeTableType(ChangeTableTypeSession changeTableTypeSession,AsyncCallback<String> callback);	
	void startUnion(UnionSession unionSession, AsyncCallback<String> callback);
		
	
	//Rows Operation
	void startEditRow(EditRowSession editRowSession,AsyncCallback<String> callback);	
	void startDeleteRows(DeleteRowsSession deleteRowsSession,AsyncCallback<String> callback);	
	void startDuplicates(DuplicatesSession duplicatesSession,AsyncCallback<String> callback);	

	//Column Operation 
	void startChangeColumnType(ChangeColumnTypeSession changeColumnTypeSession,AsyncCallback<String> callback);
	void startAddColumn(AddColumnSession addColumnSession,AsyncCallback<String> callback);
	void startDeleteColumn(DeleteColumnSession deleteColumnSession,AsyncCallback<String> callback);
	void startLabelColumn(LabelColumnSession labelColumnSession,AsyncCallback<String> callback);	
	
	/*void startSplitColumn(SplitColumnSession splitColumnSession,AsyncCallback<Void> callback);*/	
	/*void startSplitColumn(MergeColumnSession mergeColumnSession,AsyncCallback<Void> callback);	*/
	/*void startGroupBy(GroupBySession groupBySession,AsyncCallback<Void> callback);*/	
	
	
	
	//BatchReplace Operation
	void getOccurrencesForBatchReplace(OccurrencesForReplaceBatchColumnSession occurrencesForReplaceBatchColumnSession, AsyncCallback<ArrayList<Occurrences>> callback); 
	void startReplaceBatchColumn(ReplaceBatchColumnSession replaceBatchColumnSession,AsyncCallback<String> callback);	
	
	//Replace Operation
	void startReplaceColumn(ReplaceColumnSession replaceColumnSession,AsyncCallback<String> callback);	
	
	//Templates
	void getTemplates(AsyncCallback<ArrayList<TemplateData>> callback);
	void startTemplateApply(TemplateApplySession templateDeleteSession,AsyncCallback<String> callback);	
	void templateDelete(TemplateDeleteSession templateDeleteSession,AsyncCallback<Void> callback);	
	
	//Locales
	void getLocales(AsyncCallback<ArrayList<String>> callback);
	
	//History
	void getHistory(AsyncCallback<ArrayList<OpHistory>> callback);
	void getHistory(TRId trId, AsyncCallback<ArrayList<OpHistory>> callback);
	void getLastOperationInfo(AsyncCallback<OpHistory> callback);
	void getLastOperationInfo(TRId trId, AsyncCallback<OpHistory> callback);
	
	//Helper Extract Codelist
	void startExtractCodelist(ExtractCodelistSession extractCodelistSession, AsyncCallback<String> callback);
	
	//Helper Codelist Mapping Import		
	void setCodelistMappingSession(CodelistMappingSession codelistMappingSession, AsyncCallback<Void> callback);
	void getFileFromWorkspace(CodelistMappingSession codelistMappingSession, AsyncCallback<Void> callback);		
	void startCodelistMappingImport(CodelistMappingSession codelistMappingSession, AsyncCallback<String> callback);
	
	//Normalization
	void startNormalization(NormalizationSession normalizationSession, AsyncCallback<String> callback);
	
	//Denormalization	
	void startDenormalization(DenormalizationSession denormalizationSession, AsyncCallback<String> callback);
	
	//Operation Monitor
	void getOperationMonitor(OperationMonitorSession operationMonitorSession, AsyncCallback<OperationMonitor> callback);
	
	//File Upload Monitor
	void getFileUploadMonitor(AsyncCallback<FileUploadMonitor> callback);
		
	
}
